#ifdef GL_ES
precision mediump float;
#endif

#define Blend(base, blend, funcf) 		vec3(funcf(base.r, blend.r), funcf(base.g, blend.g), funcf(base.b, blend.b))
#define BlendOverlayf(base, blend) 	(base < 0.5 ? (2.0 * base * blend) : (1.0 - 2.0 * (1.0 - base) * (1.0 - blend)))
#define BlendOverlay(base, blend) 		Blend(base, blend, BlendOverlayf)

#define BlendAlphaNonPremultiplied(base, blend)      vec4((base.a*base.r) + ((1.0-base.a)*blend.r), (base.a*base.g) + ((1.0-base.a)*blend.g), (base.a*base.b) + ((1.0-base.a)*blend.b), blend.a)


//uniform sampler2D u_texture;
uniform vec3 u_targetColor;
uniform float u_percent;
varying vec2 v_texCoord;
varying vec4 v_fragmentColor;

void main(void)
{
    //vec4 color = texture2D(u_texture, v_texCoord).rgba;
    vec4 color = texture2D(CC_Texture0, v_texCoord);
    vec4 blendColor = vec4(u_targetColor, u_percent);
    
    //vec4 pass1 = vec4(BlendOverlay(color, u_targetColor), u_targetColor.a);
    vec4 pass1 = vec4(BlendOverlay(color, blendColor), u_percent);
    
    if (color.a > 0.0)
        gl_FragColor = BlendAlphaNonPremultiplied(pass1, color);
    else
        gl_FragColor = color;
}
