precision lowp float;
varying vec4 v_fragmentColor; 
varying vec2 v_texCoord;

uniform vec3 u_targetColor;
uniform float u_percent;

void main() 
{
    //vec4 texColor = texture2D(CC_Texture0, v_texCoord);
    //gl_FragColor = vec4(u_targetColor, u_percent) * texColor.a;

    //gl_FragColor = vec4(u_targetColor, u_percent) * texture2D(CC_Texture0, v_texCoord).a;


    vec4 color = texture2D(CC_Texture0, v_texCoord);
    if ( color.a > 0.0 ) {
        if (color.a != 1.0) {
            // 알파값이 1이 아닌경우, rgb 값에 알파값이 곱해진 색상이 들어오므로,
            // 원본 rgb 를 구하려면 알파값으로 나눠야 한다.
            // 그리고 적용할 색상을 구한후 다시 알파값을 곱해준다.
            color.rgb = color.rgb / color.a;

            color.rgb = vec3(color.r + (u_targetColor.r-color.r) * u_percent
                                , color.g + (u_targetColor.g-color.g) * u_percent
                                , color.b + (u_targetColor.b-color.b) * u_percent
                                ) * color.a;
            gl_FragColor = color * v_fragmentColor;
        }
        else {
            gl_FragColor = vec4(color.r + (u_targetColor.r-color.r) * u_percent
                                , color.g + (u_targetColor.g-color.g) * u_percent
                                , color.b + (u_targetColor.b-color.b) * u_percent
                                , color.a) * v_fragmentColor;
        }
    }
    else {
        gl_FragColor = color;
    }
}
