
#define MAX_LIGHT_NUM   1


//varying lowp vec3 v_fragmentColor;
varying lowp vec2 v_texCoord;

varying lowp vec2 v_texCoordMask[MAX_LIGHT_NUM];

uniform sampler2D u_texture;
uniform sampler2D u_mask;


varying lowp float v_ambient;
varying lowp float v_lightIntensity;


void main()                                                                                           
{
    // normal fragment shader (for test)
    //gl_FragColor = v_fragmentColor * texture2D(CC_Texture0, v_texCoord);

    /*
    //fragment lighting / per pixel: too slow
    mediump float distance = distance(gl_FragCoord.xyz,u_lightPosition.xyz);
    lowp float diffuse = 4.0;
    diffuse = diffuse * (1.0 / (1.0 + (0.0000025 * distance * distance)));
    */


    lowp vec4 texColor = texture2D(CC_Texture0,  v_texCoord);
    lowp float fMaskColor = texture2D(u_mask, v_texCoordMask[0]).r * v_lightIntensity + v_ambient;

    //gl_FragColor = vec4(v_fragmentColor * finalColor.rgb  , finalColor.a);
    gl_FragColor = vec4(fMaskColor * texColor.r, fMaskColor * texColor.g, fMaskColor * texColor.b, texColor.a);

}