
#define MAX_LIGHT_NUM   1

attribute vec4 a_position;
attribute vec2 a_texCoord;
//attribute vec4 a_color;

uniform mat4 u_MVPMatrix;

uniform lowp vec2 u_lightHalfLength;
uniform lowp vec2 u_lightPosition0;


// 성능을 위해 정점셰이더에서 uniform 변수를 정점셰이더에 선언하고 varying 변수로 픽셀셰이더로 넘겨준다.
// 테스트 결과 이 방식이 성능이 훨씬 좋아진다.
uniform lowp float u_ambient;
varying lowp float v_ambient;
uniform lowp float u_lightIntensity;
varying lowp float v_lightIntensity;


varying lowp vec2 v_texCoord;
varying lowp vec2 v_texCoordMask[MAX_LIGHT_NUM];
//varying lowp vec3 v_fragmentColor;

void main()
{
    // normal vertex shader
    //v_fragmentColor = a_color.rgb;
    //v_texCoord = a_texCoord;

    //gl_Position = u_MVPMatrix * a_position ;
    gl_Position = (CC_PMatrix * CC_MVMatrix) * a_position;


    //v_fragmentColor = a_color.rgb;
    v_texCoord = a_texCoord;

    v_texCoordMask[0] = (a_texCoord - (u_lightPosition0 - u_lightHalfLength) ) / (2.0*u_lightHalfLength);

    v_ambient = u_ambient;
    v_lightIntensity = u_lightIntensity;

}