/**
 * Created by kominpyo on 15. 8. 1..
 */

var FloatingManager = cc.Node.extend({
    SPAWN_NUM_PER_SEC: 60,

    ctor: function() {
        this._super();

        this.init();

    },
    init: function() {
        // Setup Pool
        for(var i = 40; i--; ) {
            var o = new Floating("#White4.png");
            cc.pool.putInPool(o);
        }

        // 변수 설정.
        this.timerSpawn = 0;

        // 초당 생성량을 0.1초마다 나눠서 생성하기 위한 구현.
        // 초당 생성량 10으로 나누면, 0.1초당 생성량이다.
        // 생성 갯수는 정수여야 하므로,
        // 길이 10인 생성갯수 배열에 몫을 각각 넣어주고, 배열 원소마다 나머지가 0이 될때까지 1씩 더해준다.
        var quotient = Math.floor(this.SPAWN_NUM_PER_SEC / 10);
        var remainder = this.SPAWN_NUM_PER_SEC - quotient * 10;
        this.arSpawnNum = new Array(10);
        for(var i = 10; i--; ) {
            this.arSpawnNum[i] = quotient;
            if( remainder > 0 ) {
                ++this.arSpawnNum[i];
                --remainder;
            }
        }
        this.idxSpawnNum = 0;

    },

    update: function(dt) {
        // 0.1초마다 생성 갯수 배열의 원소값 만큼 생성.
        this.timerSpawn += dt;
        if (this.timerSpawn >= 0.1) {
            this.timerSpawn -= 0.1;
            for (var i = this.arSpawnNum[this.idxSpawnNum]; i--;) {
                this.spawnFloating();
            }
            ++this.idxSpawnNum;
            if (this.idxSpawnNum >= 10) {
                this.idxSpawnNum = 0;
            }
        }
    },

    spawnFloating: function() {
        var o = cc.pool.getFromPool(Floating);
        if(o.parent == null ) {
            g_world.addChild(o, 50);
        }

        o.sprite.y = centerPosYOnWorldNode + g_systemManager.randomRange(-winSize.height, winSize.height) * 0.5;

        o.rotation = -g_world.rotation + g_systemManager.randomRange(-27, 27);
    }
});

var Floating = cc.Node.extend({
    ctor: function(spriteFrameName) {
        this._super();
        //this.setCascadeOpacityEnabled(true);

        this.sprite = new cc.Sprite(spriteFrameName);
        this.addChild(this.sprite);

    },
    reuse: function() {
        this.visible = true;

        //this.scheduleUpdate();

        //var floatingColorIndex = 0;
        //if( curColorIndex == 0 || curColorIndex == 1 ) {
        //    floatingColorIndex = 0;
        //}
        //else {
        //    floatingColorIndex = curColorIndex-1;
        //}

        //this.sprite.color = colorsFloating[floatingColorIndex];
        this.sprite.color = colorsFloating[curColorIndex];
        this.sprite.scale = g_systemManager.randomRange(1, 2);
        this.sprite.setOpacity(255);

        var timeAction = g_systemManager.randomRange(0.2, 1);

        var act = cc.sequence(
            cc.spawn(
                cc.scaleTo(timeAction, 0),
                cc.fadeOut(timeAction),
                cc.moveBy(timeAction, g_systemManager.randomRange(-20, 20), g_systemManager.randomRange(-20, 20))
            ),
            cc.callFunc(function(){
                cc.pool.putInPool(this);
            }, this)
        );

        this.sprite.runAction(act);

    },
    unuse: function() {
        this.visible = false;
    }

});

var colorsFloating = [
    cc.color(106, 255, 247),
    cc.color(255, 239, 113),
    cc.color(255, 239, 113),
    cc.color(255, 239, 113),
    cc.color(225, 168, 218)
];



