/**
 * Created by kominpyo on 2015. 3. 4..
 */

var g_guiLayer;

var GUILayer = cc.Layer.extend({
    ANDROID_BUTTON_CLICKED_SOUND_DELAY_TIME: 0.2,   // 안드로이드 버튼 누르고 기능이 실행될때까지의 딜레이.(사운드가 끝나고 기능이 실행되도록)

    GAUGE_TIME_MAX: 10,

    onExit: function() {
        // retain() 호출한 액션 객체 해제.
        this.actBtnSelect.release();
        this.actBtnUnselect.release();
        this.actBtnReplaySelect.release();

        this.actWhiteScreenPlayEndToMainMenu.release();

        this.actColor.release();
        this.actMMAppear.release();
        this.actMMDisappear.release();
        this.actPEAppear.release();
        this.actRedScreen.release();

        this._super();
    },

    ctor: function() {
        this._super();
        g_guiLayer = this;

        this.setupActions();
        this.setupPlay();
        this.setupMainMenu();
        this.setupPlayEnd();

        // 화면 번쩍임 연출을 위한 스프라이트.
        this.whiteScreen = new cc.Sprite("#White4A.png");
        this.addChild(this.whiteScreen, 100);
        this.whiteScreen.setScale(285, 181);
        this.whiteScreen.setPosition(winCenter);
        this.whiteScreen.visible = false;

        // 게이지 색상값 인덱스 순차랜덤 뽑는 객체.
        this.seqRandColorIndex = new SequencedRandom(colorsGauge.length);


        this.reset();

        // 로딩이미지
        if( cc.sys.os == cc.sys.OS_ANDROID ) {
            this.displayLoadingLayer();
        }
        else {
            this.loadingToMainMenu();
        }




        // 웹에서는 main.js 파일에서 씬이 다 생성되기 전에 g_systemManager.loadingToMainMenu() 가 호출되기 때문에,
        // 최고 점수 리프레시가 여기에서 필요하다.
        if( !cc.sys.isNative ) {
            this.refreshBestScore(g_systemManager.myHighScore);
        }

        // test
        //this.testSystemState();
        //this.testPlayerSpeed();
        //this.testProbBlockPosDown();
        //this.testBlockGap();
        //this.testUpperLongSpike();
        //this.testSumScoreForAd();
        //this.testPlayTime();
        //this.testGaugePosX();
        //this.testOverBall();
    },

    displayLoadingLayer: function() {
        this.loadingLayer = new LoadingLayer();
        this.addChild(this.loadingLayer, 100);

        // 일정시간후 로딩레이어 제거.
        this.scheduleOnce(function() {
            this.runAction(
                cc.sequence(
                    cc.callFunc(function() {
                        this.loadingLayer.runAction(cc.fadeOut(0.2));
                    }, this),
                    cc.delayTime(0.2),
                    cc.callFunc(function() {
                        this.loadingLayer.removeFromParent();
                        cc.textureCache.removeTextureForKey(res.LaunchAndroid_png);
                        this.loadingToMainMenu();
                    }, this)
                )
            );
        }, 1.5);
    },

    // 초기화.
    reset: function() {
        // 게이지가 마지막으로 꽉찬 시간을 저장하는 변수. 게이지 길이 리셋에 사용한다.
        this.lastGaugeFullTime = 0;
        // 게이지 색상 설정.
        this.curGaugeColorIndex = this.seqRandColorIndex.getNextElement();
        this.gauge.setColor(colorsGauge[this.curGaugeColorIndex]);
        // 게이지 밑 숫자 색상 설정.
        //this.nodeDot.setColor(colorsGauge[this.curGaugeColorIndex]);


        // 획득물 관리 배열 초기화.
        if( !this.activeGains ) {
            this.activeGains = [];
        }
        else {
            for( var i = this.activeGains.length; i--; ) {
                cc.pool.putInPool(this.activeGains[i]);
            }
            this.activeGains = [];
        }
    },

    loadingToMainMenu: function() {
        this.runAction(this.actMMAppear);
    },

    mainMenuToPlay: function() {
        // 첫 아이템 생성.
        this.spawnGainWithRandomTerm();

        //this.rootMM.visible = false;
        this.stopAllActions();
        this.runAction(this.actMMDisappear);


        // 플레이 화면 UI 페이드 인.
        this.rootPL.visible = true;

        // 게이지 앞부분 깜박임 액션 시작.
        //this.gaugeHead.visible = true;
        this.gaugeHead.runAction(this.actColor.clone());

    },

    playToPlayEnd: function() {
        // 게임 종료씬 현재 점수 세팅.
        // 점수(시간) 을 초와 밀리초 단위로 나눈다.
        var score = g_systemManager.score;
        var sec = Math.floor(score);
        var milliSec = Math.floor( (score-sec+0.001) *100 );

        this.lbPEYourTimeSec.setString(sec);
        this.lbPEYourTimeMilliSec.setString(milliSec >= 10 ? milliSec : "0"+milliSec);


        // 게이지 색상변화 멈춤.
        // 앞부분
        //this.gaugeHead.visible = false;
        this.gaugeHead.stopAllActions();


        // 게임 종료 화면을 일정시간(현재 1초) 뒤에 보여준다.
        this.displayPlayEndUI_delayed();

        // 아이템 생성 멈춤.
        this.unschedule( this.spawnGain );
    },
    displayPlayEndUI_delayed: function() {
        this.scheduleOnce(function() {
            // 리더보드 점수 등록.
            // 구글 리더보드와 게임센터에서는 점수 등록시 정수로 받는다.
            // 소수점 자리는 각각의 웹사이트 설정 페이지에서 설정한다.(구글리더보드:Developer Console , 게임센터:아이튠즈커넥트)
            // 소수점 두자리까지 점수를 표시하고 있으므로, 여기서는 100을 곱해서 전송하면 된다.
            g_systemManager.reportScore(g_systemManager.score*100);

            // 종료화면 연출 액션.
            this.runAction(this.actPEAppear);
        }, 1);
    },

    playEndToMainMenu: function() {
        this.rootPL.visible = false;

        //this.rootMM.visible = true;
        this.runAction(this.actMMAppear);


        this.rootPE.visible = false;

        // 종료화면 현재 점수 색상 변화 액션 멈춤.
        this.nodePEYourTime.stopAllActions();


        this.reset();
    },

    update: function(dt) {

    },

    flashScreen: function(time) {
        this.whiteScreen.opacity = 255;
        this.whiteScreen.runAction( cc.sequence(
            cc.show(),
            cc.fadeOut(time),
            cc.hide()
        ));
    },


    refreshBestScore: function(score) {
        // 점수(시간) 을 초와 밀리초 단위로 나눈다.
        var sec = Math.floor(score);
        var milliSec = Math.floor( (score-sec+0.001) *100 );

        // 메인화면 베스트 스코어.
        this.lbMMBestTimeSec.setString(sec);
        this.lbMMBestTimeMilliSec.setString(milliSec >= 10 ? milliSec : "0"+milliSec);

        // 종료화면 베스트 스코어.
        this.lbPEBestTimeSec.setString(sec);
        this.lbPEBestTimeMilliSec.setString(milliSec >= 10 ? milliSec : "0"+milliSec);
    },


    // UI 액션 셋업.
    setupActions: function() {
        // 버튼 눌림/떼짐 액션.
        this.actBtnSelect = cc.callFunc(function(sender) {
            this.playSoundButton();

            sender.runAction(cc.scaleTo(0.05, 1.1));

        }, this);
        this.actBtnSelect.retain();
        this.actBtnUnselect = cc.callFunc(function(sender) {
            sender.runAction(cc.scaleTo(0.05, 1));
        }, this);
        this.actBtnUnselect.retain();

        // 리플레이 버튼 눌림 액션.
        this.actBtnReplaySelect = cc.callFunc(function(sender) {
            sender.runAction(cc.scaleTo(0.05, 1.1));
        }, this);
        this.actBtnReplaySelect.retain();

        // PlayEnd=>MainMenu 화면 번쩍임 액션.
        this.actWhiteScreenPlayEndToMainMenu = cc.sequence(
            cc.callFunc(function() {
                PButton.enabled = false;
            }, this),
            cc.show(),
            cc.fadeIn(0.1),
            cc.delayTime(0.1),
            cc.callFunc(function() {
                g_systemManager.playEndToMainMenu();
            }, this),
            cc.fadeOut(0.1),
            cc.hide()
            // 메인화면 등장 액션에서 PButton.enabled = true; 를 해주므로 여기서는 삭제함.
            //cc.callFunc(function() {
            //    PButton.enabled = true;
            //}, this)
        );
        this.actWhiteScreenPlayEndToMainMenu.retain();

        // 메인메뉴 Touch To Play 아이콘 깜박임.
        this.actWordTouchToPlayIdle = cc.repeatForever(
            cc.sequence(
                cc.fadeOut(0.5),
                cc.fadeIn(0.5)
            )
        );
        this.actWordTouchToPlayIdle.retain();


        // 색상 변화 액션.
        var timeTint = 0.12;
        this.actColor = cc.repeatForever(
            cc.sequence(
                cc.tintTo(timeTint, 255,202,0),
                cc.tintTo(timeTint, 255,80,255),
                cc.tintTo(timeTint, 0,179,255)
            )
        );
        this.actColor.retain();

        // 메인화면 등장 연출
        this.actMMAppear = cc.sequence(
            cc.callFunc(function() {
                this.rootMM.visible = true;
                PButton.enabled = false;


                // 타이틀 액션.
                this.title.x = -winSize.width*0.5 -404;     // 404: 타이틀 스프라이트 너비 / 2
                this.title.runAction(new cc.EaseElasticOut(cc.moveTo(1, 0, 0), 0.3));

                // 버튼 액션.
                var btnMoveDist = 310;
                this.mmBtnLeaderboard.y = -btnMoveDist;
                this.btnRate.y = -btnMoveDist;

                var actBtn = new cc.EaseElasticOut(cc.moveTo(1, 0,0), 0.3);
                this.mmBtnLeaderboard.runAction(actBtn.clone());
                this.btnRate.runAction(actBtn.clone());

                // 베스트 스코어 액션.
                this.nodeMMBestScore.setOpacity(0);
                this.nodeMMBestScore.runAction(cc.fadeIn(1));

                // 메인화면 베스트 스코어 색상 변화 액션 시작.
                this.nodeMMDot.runAction(this.actColor.clone());


                // 터치 투 플레이 액션.
                this.touchToPlay.setOpacity(0);
                this.touchToPlay.stopAllActions();
                this.touchToPlay.runAction(cc.fadeIn(1));
            }, this),
            cc.delayTime(0.7),
            cc.callFunc(function() {
                PButton.enabled = true;
            }, this),
            cc.delayTime(0.3),
            cc.callFunc(function() {
                this.touchToPlay.runAction(this.actWordTouchToPlayIdle);
            }, this)
        );
        this.actMMAppear.retain();

        // 메인화면 사라짐 연출.
        this.actMMDisappear = cc.sequence(
            cc.callFunc(function() {
                var actTime = 0.2;
                this.title.stopAllActions();
                this.title.runAction(cc.moveBy(actTime, winSize.width*1.5, 0));

                var actBtn = cc.moveBy(actTime, 0, -winSize.height);
                this.mmBtnLeaderboard.stopAllActions();
                this.btnRate.stopAllActions();
                this.mmBtnLeaderboard.runAction(actBtn.clone());
                this.btnRate.runAction(actBtn.clone());

                this.nodeMMBestScore.stopAllActions();
                this.nodeMMBestScore.runAction(cc.fadeOut(actTime));

                this.touchToPlay.stopAllActions();
                this.touchToPlay.runAction(cc.fadeOut(actTime));

            }, this),
            cc.delayTime(0.2),
            cc.callFunc(function() {
                this.rootMM.visible = false;

                // 메인화면 베스트 스코어 색상 변화 멈춤.
                this.nodeMMDot.stopAllActions();

            }, this)
        );
        this.actMMDisappear.retain();


        // 종료화면 등장 연출
        this.actPEAppear = cc.sequence(
            cc.callFunc(function() {
                this.rootPE.visible = true;
                PButton.enabled = false;

                // 스코어 액션.
                this.nodePEYourScore.x = -700;
                this.nodePEYourScore.runAction(new cc.EaseExponentialOut(cc.moveTo(0.5, 0, 0)));
                this.nodePEBestScore.x = -700;

                // 버튼 액션 준비.
                var btnMoveDist = 310;
                this.peBtnLeaderboard.y = -btnMoveDist;
                this.btnShare.y = -btnMoveDist;

                this.btnReplay.y = -370;


                // 현재 점수 색상 깜박임 액션.
                this.nodePEYourTime.runAction(this.actColor.clone());

            }, this),
            cc.delayTime(0.1),
            cc.callFunc(function() {
                this.nodePEBestScore.runAction(new cc.EaseExponentialOut(cc.moveTo(0.5, 0, 0)));
            }, this),
            cc.delayTime(0.2),
            cc.callFunc(function() {
                // 리더보드, 공유버튼 액션.
                var actBtn = new cc.EaseElasticOut(cc.moveTo(1, 0,0), 0.3);
                this.peBtnLeaderboard.runAction(actBtn.clone());
                this.btnShare.runAction(actBtn.clone());

            }, this),
            cc.delayTime(0.2),
            cc.callFunc(function() {
                // 리플레이 버튼 액션.
                var actBtn = new cc.EaseElasticOut(cc.moveTo(0.7, 0,0), 0.5);
                this.btnReplay.runAction(actBtn.clone());

            }, this),
            cc.delayTime(0.5),
            cc.callFunc(function() {
                g_systemManager.showInterstitialAdByCondition();
                PButton.enabled = true;
            }, this)
        );
        this.actPEAppear.retain();


        // 죽음시 붉은 화면외곽 페이드 인/아웃 액션
        this.actRedScreen = cc.sequence(
            cc.show(),
            cc.fadeIn(0.15),
            cc.fadeOut(0.15),
            cc.hide()
        );
        this.actRedScreen.retain();

    },


    // 플레이씬 UI 셋업
    setupPlay: function() {
        // rootPL : 플레이화면 루트 노드. 모든 메인메뉴 UI 를 여기에 붙인다.
        this.rootPL = new cc.Node();
        this.addChild(this.rootPL, 0);
        this.rootPL.visible = false;
        this.rootPL.setCascadeOpacityEnabled(true);

        // TopSign 배경 검은색 얇게 한줄.
        this.bgTopSign = new cc.Sprite(res.White4A_png);
        this.addChild(this.bgTopSign, 1);
        this.bgTopSign.setAnchorPoint(0.5, 0);
        this.bgTopSign.setPosition(winCenter.x, winSize.height-8);
        this.bgTopSign.setScale(292, 12);
        this.bgTopSign.setColor(cc.color(0,0,0));

        // 게이지.
        GAUGE_HEIGHT = winSize.height -25;
        this.gauge = new cc.ProgressTimer(new cc.Sprite("#Gauge.png"));
        this.rootPL.addChild(this.gauge);
        this.gauge.setAnchorPoint(0, 1);
        //this.gauge.y = winSize.height -7;
        this.gauge.y = winSize.height -5;

        this.gauge.setType(cc.ProgressTimer.TYPE_BAR);
        this.gauge.setMidpoint(cc.p(0, 1));
        this.gauge.setBarChangeRate(cc.p(1, 0));
        this.gauge.setPercentage(0);
        this.gauge.setScaleX(winSize.width/1136);

        //this.gaugeScaleMax = winSize.width/4;
        //this.gaugeScaleMax = winSize.width/1136;

        // 게이지 앞부분 이펙트 스프라이트
        //this.gaugeHead = new cc.Sprite(res.White4A_png);
        //this.rootPL.addChild(this.gaugeHead);
        //this.gaugeHead.setAnchorPoint(0, 1);
        //this.gaugeHead.y = this.gauge.y;
        //this.gaugeHead.setScale(6/4, 18/4);
        this.gaugeHead = new cc.Sprite("#GaugeHead.png");
        this.rootPL.addChild(this.gaugeHead);
        this.gaugeHead.setAnchorPoint(0.5, 1);
        this.gaugeHead.y = this.gauge.y;



        // 플레이 타임.
        // 플레이 타임 루트.
        //this.widthTime = 96;
        this.widthTime = 117;
        this.rootTime = new cc.Node();
        this.rootPL.addChild(this.rootTime);
        this.rootTime.setPosition(this.widthTime, winSize.height -45);
        // 플레이 타임 점.
        this.nodeDot = new cc.Node();
        this.rootTime.addChild(this.nodeDot);
        this.nodeDot.x = -48;
        this.nodeDot.setCascadeColorEnabled(true);
        this.dot = new cc.Sprite("#Dot.png");
        this.nodeDot.addChild(this.dot);
        this.dot.y = -9;
        this.dot.setScale(0.5);
        // 왼쪽 숫자.
        this.lbTimeSec = new cc.LabelAtlas("0", res.NumberTime_png, 22, 25, '0');
        this.nodeDot.addChild(this.lbTimeSec);
        this.lbTimeSec.setAnchorPoint(1, 0.5);
        this.lbTimeSec.x = -6;
        // 오른쪽 숫자.
        this.lbTimeMilliSec = new cc.LabelAtlas("0", res.NumberTime_png, 22, 25, '0');
        this.nodeDot.addChild(this.lbTimeMilliSec);
        this.lbTimeMilliSec.setAnchorPoint(0, 0.5);
        this.lbTimeMilliSec.x = 6;

        this.nodeDot.setColor(cc.color(0,0,0));


        // 죽음시 붉은 화면외곽 스프라이트.
        this.redScreen = new cc.Sprite("#EffectHit.png");
        this.addChild(this.redScreen, 4);
        this.redScreen.visible = false;
        this.redScreen.setPosition(winCenter);
        // 해상도에 따라 스케일 설정.
        var screenRatio = winSize.width / winSize.height;
        var normalScale = 2.1;
        if( screenRatio >= 1.5 ) {
            this.redScreen.setScale(screenRatio/1.5 *normalScale, normalScale);
        }
        else {
            this.redScreen.setScale(normalScale, (winSize.height/winSize.width)/(2/3) *normalScale);
        }


        // TopSign 과 SideSign 을 붙일 노드.
        this.rootSigns = new cc.Node();
        this.addChild(this.rootSigns, 2);

    },

    refreshGauge: function(timerPlay) {
        // 게이지 다 찼는가?
        if( timerPlay > this.lastGaugeFullTime + this.GAUGE_TIME_MAX ) {
            this.lastGaugeFullTime += this.GAUGE_TIME_MAX;
            // 게이지 색상 랜덤 설정.
            this.curGaugeColorIndex = this.seqRandColorIndex.getNextElement();
            this.gauge.setColor(colorsGauge[this.curGaugeColorIndex]);
            //this.nodeDot.setColor(colorsGauge[this.curGaugeColorIndex]);

            // 땅 색상 변경.
            g_playLayer.changeLandColor();
        }

        //this.gauge.setScaleX((timerPlay-this.lastGaugeFullTime)/this.GAUGE_TIME_MAX * this.gaugeScaleMax);
        var gaugeRate = (timerPlay-this.lastGaugeFullTime)/this.GAUGE_TIME_MAX;
        this.gauge.setPercentage(gaugeRate *100);

        // 시간 폰트 숫자 설정.
        var sec = Math.floor(timerPlay);
        var milliSec = Math.floor( (timerPlay-sec+0.001) *100 );
        this.lbTimeSec.setString(sec);
        this.lbTimeMilliSec.setString(milliSec >= 10 ? milliSec : "0"+milliSec);

        // 시간 폰트 위치 설정.
        //this.gaugePosX = this.gauge.getScaleX()/this.gaugeScaleMax * winSize.width;
        this.gaugePosX = gaugeRate * winSize.width;
        if( this.gaugePosX < this.widthTime ) {
            this.rootTime.x = this.widthTime;
        }
        else {
            this.rootTime.x = this.gaugePosX;
        }

        // 게이지 앞부분 반짝임 위치 설정.
        this.gaugeHead.x = this.gaugePosX;
    },

    getGaugePosXAfterTime: function(time) {
        var gaugePosX = this.gaugePosX + time/this.GAUGE_TIME_MAX * winSize.width;
        if( gaugePosX > winSize.width ) {
            gaugePosX -= winSize.width;
        }
        return gaugePosX;
    },

    runEffectGaugeColor: function() {
        this.gauge.runAction(this.actColor.clone());
        //this.nodeDot.runAction(this.actColor.clone());

        this.scheduleOnce(function() {
            this.gauge.stopAllActions();
            //this.nodeDot.stopAllActions();

            var color = colorsGauge[curColorIndex];
            this.gauge.runAction(cc.tintTo(0.3, color.r, color.g, color.b));
            //this.nodeDot.runAction(cc.tintTo(0.3, color.r, color.g, color.b));
        }, 1);
    },

    runEffectRedScreen: function() {
        this.redScreen.setOpacity(0);
        this.redScreen.runAction(this.actRedScreen);
    },

    spawnGainWithRandomTerm: function() {
        this.scheduleOnce(this.spawnGain, g_systemManager.randomRangeUnit(3,5,1));
    },
    spawnGain: function() {
        var o = cc.pool.getFromPool(Gain);
        if(o.parent == null ) {
            g_world.addChild(o, 22);
        }
        this.activeGains.push(o);

        o.y = winSize.height + 15;
        var posOffsetX = 100;
        o.x = g_systemManager.randomRange(posOffsetX, winSize.width -posOffsetX);

    },


    // 메인메뉴 UI 셋업
    setupMainMenu: function() {
        // rootMM : 메인메뉴 루트 노드. 모든 메인메뉴 UI 를 여기에 붙인다.
        this.rootMM = new cc.Node();
        this.addChild(this.rootMM, 5);
        this.rootMM.visible = false;
        this.rootMM.setCascadeOpacityEnabled(true);

        // 타이틀
        var nodeTitle = new cc.Node();
        this.rootMM.addChild(nodeTitle);
        nodeTitle.setPosition(winCenter.x, winCenter.y +150);
        this.title = new cc.Sprite("#Title.png");
        nodeTitle.addChild(this.title);

        // 터치 투 플레이 스프라이트.
        this.touchToPlay = new cc.Sprite("#TouchToPlay.png");
        this.rootMM.addChild(this.touchToPlay);
        this.touchToPlay.setPosition(winCenter.x, winCenter.y -45);

        // 베스트 스코어 노드.
        this.nodeMMBestScore = new cc.Node();
        this.rootMM.addChild(this.nodeMMBestScore);
        this.nodeMMBestScore.setPosition(winCenter.x, winCenter.y +35);
        this.nodeMMBestScore.setCascadeOpacityEnabled(true);
        // 베스트 스코어-콜론
        this.mmColon = new cc.Sprite("#Colon.png");
        this.nodeMMBestScore.addChild(this.mmColon);
        this.mmColon.setColor(colorsGauge[0]);
        // 베스트 스코어-글자.
        this.mmBestScore = new cc.Sprite("#WordBest.png");
        this.nodeMMBestScore.addChild(this.mmBestScore);
        this.mmBestScore.setAnchorPoint(1, 0.5);
        this.mmBestScore.x = -30;
        this.mmBestScore.y = 10;
        this.mmBestScore.setColor(colorsGauge[0]);
        // 베스트 스코어-숫자
        var widthTime = 152;
        this.nodeMMBestTime = new cc.Node();
        this.nodeMMBestScore.addChild(this.nodeMMBestTime);
        this.nodeMMBestTime.setCascadeOpacityEnabled(true);
        this.nodeMMBestTime.x = 45;
        // 베스트 스코어-숫자-점
        this.nodeMMDot = new cc.Node();
        this.nodeMMBestTime.addChild(this.nodeMMDot);
        this.nodeMMDot.setCascadeOpacityEnabled(true);
        this.nodeMMDot.setCascadeColorEnabled(true);
        this.nodeMMDot.x = widthTime/2;
        var dot = new cc.Sprite("#Dot.png");
        this.nodeMMDot.addChild(dot);
        dot.y = -9;
        dot.setScale(0.5);
        // 베스트 스코어-왼쪽 숫자.
        this.lbMMBestTimeSec = new cc.LabelAtlas("0", res.NumberScoreMain_png, 30, 34, '0');
        this.nodeMMDot.addChild(this.lbMMBestTimeSec);
        this.lbMMBestTimeSec.setAnchorPoint(1, 0.5);
        this.lbMMBestTimeSec.x = -6;
        // 베스트 스코어-오른쪽 숫자.
        this.lbMMBestTimeMilliSec = new cc.LabelAtlas("0", res.NumberScoreMain_png, 30, 34, '0');
        this.nodeMMDot.addChild(this.lbMMBestTimeMilliSec);
        this.lbMMBestTimeMilliSec.setAnchorPoint(0, 0.5);
        this.lbMMBestTimeMilliSec.x = 6;

        this.nodeMMDot.setColor(colorsGauge[0]);



        var btnPosYFromCenter = -100;
        var btnPosXFromSide = 100;

        // 리더보드 버튼
        this.nodeMMBtnLeaderboard = new cc.Node();      // 버튼 상위노드. 해상도 대응을 위해 위치만 잡아준다. 모든 버튼이 마찬가지이다.
        this.rootMM.addChild(this.nodeMMBtnLeaderboard);
        this.nodeMMBtnLeaderboard.setPosition(btnPosXFromSide, winCenter.y +btnPosYFromCenter);
        this.nodeMMBtnLeaderboard.setCascadeOpacityEnabled(true);

        this.mmBtnLeaderboard = new PButton(
            new cc.Sprite("#ButtonGamecenter0.png"),
            "ButtonGamecenter1.png",
            function() {
                if( cc.sys.os == cc.sys.OS_ANDROID ) {
                    PButton.enabled = false;

                    this.scheduleOnce(function() {
                        g_systemManager.showLeaderboard();
                    }, this.ANDROID_BUTTON_CLICKED_SOUND_DELAY_TIME);

                    this.scheduleOnce(function() {
                        PButton.enabled = true;
                    }, this.ANDROID_BUTTON_CLICKED_SOUND_DELAY_TIME+0.1);
                }
                else {
                    g_systemManager.showLeaderboard();
                }
            }, this,
            this.actBtnSelect.clone(),
            this.actBtnUnselect.clone()
        );
        this.nodeMMBtnLeaderboard.addChild(this.mmBtnLeaderboard);
        this.mmBtnLeaderboard.setCascadeOpacityEnabled(true);


        // 레이트 버튼
        this.nodeBtnRate = new cc.Node();      // 버튼 상위노드. 해상도 대응을 위해 위치만 잡아준다. 모든 버튼이 마찬가지이다.
        this.rootMM.addChild(this.nodeBtnRate);
        this.nodeBtnRate.setPosition(winSize.width -btnPosXFromSide, winCenter.y +btnPosYFromCenter);
        this.nodeBtnRate.setCascadeOpacityEnabled(true);

        this.btnRate = new PButton(
            new cc.Sprite("#ButtonRate0.png"),
            "ButtonRate1.png",
            function() {
                if( cc.sys.os == cc.sys.OS_ANDROID ) {
                    PButton.enabled = false;

                    this.scheduleOnce(function() {
                        g_systemManager.openReviewPage();
                    }, this.ANDROID_BUTTON_CLICKED_SOUND_DELAY_TIME);

                    this.scheduleOnce(function() {
                        PButton.enabled = true;
                    }, this.ANDROID_BUTTON_CLICKED_SOUND_DELAY_TIME+0.1);
                }
                else {
                    g_systemManager.openReviewPage();
                }
            }, this,
            this.actBtnSelect.clone(),
            this.actBtnUnselect.clone()
        );
        this.nodeBtnRate.addChild(this.btnRate);
        this.btnRate.setCascadeOpacityEnabled(true);
    },

    // 게임 종료화면 UI 셋업
    setupPlayEnd: function() {
        // rootMM : 메인메뉴 루트 노드. 모든 메인메뉴 UI 를 여기에 붙인다.
        this.rootPE = new cc.Node();
        this.addChild(this.rootPE, 5);
        this.rootPE.visible = false;


        // 종료화면 배경.
        //this.peBg = new cc.Sprite("#White4A.png");
        //this.rootPE.addChild(this.peBg);
        //this.peBg.setScale(285, 181);
        //this.peBg.setPosition(winCenter);
        //this.peBg.setOpacity(204);
        this.peBg = new cc.Sprite("#Bg.png");
        this.rootPE.addChild(this.peBg);
        this.peBg.setPosition(winCenter);
        this.peBg.setOpacity(217);


        var scorePosXFromCenter = 170;
        var scorePosYFromCenter = 120;
        var numberPosXFromDot = 15;
        // 베스트 스코어 루트.
        this.rootPEBestScore = new cc.Node();
        this.rootPE.addChild(this.rootPEBestScore);
        this.rootPEBestScore.setPosition(winCenter.x -scorePosXFromCenter, winCenter.y +scorePosYFromCenter);
        // 베스트 스코어 노드.
        this.nodePEBestScore = new cc.Node();
        this.rootPEBestScore.addChild(this.nodePEBestScore);
        this.nodePEBestScore.setCascadeColorEnabled(true);
        // 베스트 스코어-글자.
        this.mmBestScore = new cc.Sprite("#WordBest.png");
        this.nodePEBestScore.addChild(this.mmBestScore);
        this.mmBestScore.y = 86;
        // 베스트 스코어-숫자
        this.nodePEBestTime = new cc.Node();
        this.nodePEBestScore.addChild(this.nodePEBestTime);
        this.nodePEBestTime.setCascadeColorEnabled(true);
        // 베스트 스코어-숫자-점
        var dot = new cc.Sprite("#Dot.png");
        this.nodePEBestTime.addChild(dot);
        dot.setScale(1);
        dot.y = -28;
        // 베스트 스코어-왼쪽 숫자.
        this.lbPEBestTimeSec = new cc.LabelAtlas("0", res.NumberScoreEnd_png, 55, 63, '0');
        this.nodePEBestTime.addChild(this.lbPEBestTimeSec);
        this.lbPEBestTimeSec.setAnchorPoint(1, 0.5);
        this.lbPEBestTimeSec.x = -numberPosXFromDot;
        // 베스트 스코어-오른쪽 숫자.
        this.lbPEBestTimeMilliSec = new cc.LabelAtlas("0", res.NumberScoreEnd_png, 55, 63, '0');
        this.nodePEBestTime.addChild(this.lbPEBestTimeMilliSec);
        this.lbPEBestTimeMilliSec.setAnchorPoint(0, 0.5);
        this.lbPEBestTimeMilliSec.x = numberPosXFromDot;

        this.nodePEBestScore.setColor(cc.color(0,0,0));


        // 현재 스코어 루트.
        this.rootPEYourScore = new cc.Node();
        this.rootPE.addChild(this.rootPEYourScore);
        this.rootPEYourScore.setPosition(winCenter.x +scorePosXFromCenter, winCenter.y +scorePosYFromCenter);
        // 현재 스코어 노드.
        this.nodePEYourScore = new cc.Node();
        this.rootPEYourScore.addChild(this.nodePEYourScore);
        // 현재 스코어-글자.
        this.peYourScore = new cc.Sprite("#WordYour.png");
        this.nodePEYourScore.addChild(this.peYourScore);
        this.peYourScore.y = 70;
        this.peYourScore.setColor(colorsGauge[2]);
        // 현재 스코어-숫자
        this.nodePEYourTime = new cc.Node();
        this.nodePEYourScore.addChild(this.nodePEYourTime);
        this.nodePEYourTime.setCascadeColorEnabled(true);
        // 현재 스코어-숫자-점
        var dot = new cc.Sprite("#Dot.png");
        this.nodePEYourTime.addChild(dot);
        dot.setScale(1);
        dot.y = -28;
        // 현재 스코어-왼쪽 숫자.
        this.lbPEYourTimeSec = new cc.LabelAtlas("0", res.NumberScoreEnd_png, 55, 63, '0');
        this.nodePEYourTime.addChild(this.lbPEYourTimeSec);
        this.lbPEYourTimeSec.setAnchorPoint(1, 0.5);
        this.lbPEYourTimeSec.x = -numberPosXFromDot;
        // 현재 스코어-오른쪽 숫자.
        this.lbPEYourTimeMilliSec = new cc.LabelAtlas("0", res.NumberScoreEnd_png, 55, 63, '0');
        this.nodePEYourTime.addChild(this.lbPEYourTimeMilliSec);
        this.lbPEYourTimeMilliSec.setAnchorPoint(0, 0.5);
        this.lbPEYourTimeMilliSec.x = numberPosXFromDot;



        var btnPosYFromCenter = -100;

        // 리플레이 버튼. (=홈 버튼)
        this.nodeBtnReplay = new cc.Node();      // 버튼 상위노드. 해상도 대응을 위해 위치만 잡아준다. 모든 버튼이 마찬가지이다.
        this.rootPE.addChild(this.nodeBtnReplay);
        this.nodeBtnReplay.setPosition(winCenter.x, winCenter.y +btnPosYFromCenter);
        this.nodeBtnReplay.setCascadeOpacityEnabled(true);

        this.btnReplay = new PButton(
            new cc.Sprite("#ButtonPlay0.png"),
            "ButtonPlay1.png",
            function() {
                //g_systemManager.playEndToMainMenu();

                this.playSoundButton();

                this.whiteScreen.setOpacity(0);
                this.whiteScreen.runAction(this.actWhiteScreenPlayEndToMainMenu);
            }, this,
            this.actBtnReplaySelect.clone(),
            this.actBtnUnselect.clone()
        );
        this.nodeBtnReplay.addChild(this.btnReplay);



        var btnPosXFromSide = 100;

        // 리더보드 버튼.
        this.nodePEBtnLeaderboard = new cc.Node();      // 버튼 상위노드. 해상도 대응을 위해 위치만 잡아준다. 모든 버튼이 마찬가지이다.
        this.rootPE.addChild(this.nodePEBtnLeaderboard);
        this.nodePEBtnLeaderboard.setPosition(btnPosXFromSide, winCenter.y +btnPosYFromCenter);
        this.nodePEBtnLeaderboard.setCascadeOpacityEnabled(true);

        this.peBtnLeaderboard = new PButton(
            new cc.Sprite("#ButtonGamecenter0.png"),
            "ButtonGamecenter1.png",
            function() {
                if( cc.sys.os == cc.sys.OS_ANDROID ) {
                    PButton.enabled = false;

                    this.scheduleOnce(function() {
                        g_systemManager.showLeaderboard();
                    }, this.ANDROID_BUTTON_CLICKED_SOUND_DELAY_TIME);

                    this.scheduleOnce(function() {
                        PButton.enabled = true;
                    }, this.ANDROID_BUTTON_CLICKED_SOUND_DELAY_TIME+0.1);
                }
                else {
                    g_systemManager.showLeaderboard();
                }
            }, this,
            this.actBtnSelect.clone(),
            this.actBtnUnselect.clone()
        );
        this.nodePEBtnLeaderboard.addChild(this.peBtnLeaderboard);
        this.peBtnLeaderboard.setCascadeOpacityEnabled(true);

        // 공유 버튼.
        this.nodeBtnShare = new cc.Node();      // 버튼 상위노드. 해상도 대응을 위해 위치만 잡아준다. 모든 버튼이 마찬가지이다.
        this.rootPE.addChild(this.nodeBtnShare);
        this.nodeBtnShare.setPosition(winSize.width -btnPosXFromSide , winCenter.y +btnPosYFromCenter);
        this.nodeBtnShare.setCascadeOpacityEnabled(true);

        this.btnShare = new PButton(
            new cc.Sprite("#ButtonShare0.png"),
            "ButtonShare1.png",
            function() {
                if( cc.sys.os == cc.sys.OS_ANDROID ) {
                    PButton.enabled = false;

                    this.scheduleOnce(function() {
                        g_systemManager.showShareView(g_systemManager.score);
                    }, this.ANDROID_BUTTON_CLICKED_SOUND_DELAY_TIME);

                    this.scheduleOnce(function() {
                        PButton.enabled = true;
                    }, this.ANDROID_BUTTON_CLICKED_SOUND_DELAY_TIME+0.1);
                }
                else {
                    g_systemManager.showShareView(g_systemManager.score);
                }
            }, this,
            this.actBtnSelect.clone(),
            this.actBtnUnselect.clone()
        );
        this.nodeBtnShare.addChild(this.btnShare);
        this.btnShare.setCascadeOpacityEnabled(true);
    },

    playSoundButton: function() {
        cc.audioEngine.playEffect(res.SoundButton);
    },

    countLbsTest: 0,
    lbsTest: [],
    setLabelTest: function(labelNum) {
        for( var i = this.countLbsTest; i < this.countLbsTest+labelNum; ++i ) {
            this.lbsTest[i] = new cc.LabelTTF("temp label", "Arial", 20);
            this.addChild(this.lbsTest[i]);
            this.lbsTest[i].setPosition(cc.p(0, winSize.height - i * 20));
            this.lbsTest[i].setAnchorPoint(cc.p(0, 1));
        }
        this.countLbsTest += labelNum;
        return this.countLbsTest-labelNum;
    },

    testOverBall: function() {
        var idx = this.setLabelTest(2);
        this.lbsTest[idx].color = cc.color(255,0,0);
        this.lbsTest[idx+1].color = cc.color(255,0,0);
        //this.lbsTest[idx].scale = 2;
        this.schedule(function(dt) {
            this.lbsTest[idx].setString("OverBall: "+BallManager.countTestOverBall);
            this.lbsTest[idx+1].setString("DownedBall: "+BallManager.countTestDownedBall);
        }, 0.03);
    },

    testGaugePosX: function() {
        var idx = this.setLabelTest(1);
        this.lbsTest[idx].color = cc.color(255,0,0);
        //this.lbsTest[idx].scale = 2;
        this.schedule(function(dt) {
            this.lbsTest[idx].setString("GaugePosX: "+Math.floor(this.gaugePosX*10)/10);
        }, 0.03);
    },

    testPlayTime: function() {
        var idx = this.setLabelTest(1);
        this.lbsTest[idx].color = cc.color(0,0,0);
        //this.lbsTest[idx].scale = 2;
        this.schedule(function(dt) {
            this.lbsTest[idx].setString("PlayTime: "+Math.floor(g_systemManager.score*10)/10);
        }, 0.03);
    },

    testSumScoreForAd: function() {
        var idx = this.setLabelTest(2);
        this.lbsTest[idx].color = cc.color(0,0,0);
        this.lbsTest[idx+1].color = cc.color(0,0,0);
        this.schedule(function(dt) {
            this.lbsTest[idx].setString("countPlayNumForAd: "+g_systemManager.countPlayNumForAd);
            this.lbsTest[idx+1].setString("SumScoreForAd: "+g_systemManager.sumScoreForAd);
        }, 0.1);
    },

    testUpperLongSpike: function() {
        this.setLabelTest(1);
        this.lbsTest[0].color = cc.color(0,0,0);
        this.schedule(function(dt) {
            this.lbsTest[0].setString("nextUpperLongSpike: "+g_ballManager.nextUpperLongSpike);
        }, 0.1);
    },

    testBlockGap: function() {
        this.setLabelTest(2);
        this.schedule(function(dt) {
            this.lbsTest[0].setString("BlockGapMin: "+g_ballManager.BLOCK_ROTATION_GAP_MIN);
            this.lbsTest[1].setString("BlockGapMax: "+g_ballManager.curBlockRotGapMax);
        }, 0.1);
    },

    testProbBlockPosDown: function() {
        this.setLabelTest(1);
        this.schedule(function(dt) {
            this.lbsTest[0].setString("probBlockPosDown: "+g_ballManager.probBlockPosDown);
        });
    },

    testPlayerSpeed: function() {
        this.setLabelTest(1);
        this.schedule(function(dt) {
            this.lbsTest[0].setString("player Speed: "+g_player.rotateSpeed);
        });
    },

    testSystemState: function() {
        this.setLabelTest(1);
        this.curSystemState = g_systemManager.systemState;
        this.schedule(function(dt) {
            if( this.curSystemState != g_systemManager.systemState ) {
                this.curSystemState = g_systemManager.systemState;
                if( this.curSystemState == 0 ) { this.lbsTest[0].setString("SystemState: Loading"); }
                else if( this.curSystemState == 1 ) { this.lbsTest[0].setString("SystemState: MainMenu"); }
                else if( this.curSystemState == 2 ) { this.lbsTest[0].setString("SystemState: Play"); }
                else if( this.curSystemState == 3 ) { this.lbsTest[0].setString("SystemState: PlayEnd"); }
                else if( this.curSystemState == 4 ) { this.lbsTest[0].setString("SystemState: Pause"); }
            }
        }, 0.3);
    },

    testDrawNode: function() {
        this.drawNode0 = new cc.DrawNode();
        this.addChild(this.drawNode0, 10);
        this.drawNode0.drawRect(cc.p(0,0), cc.p(50,50), null, 5, cc.color(255,0,0,255));

        this.resetDrawNode = function() {
            this.drawNode0.clear();
            this.drawNode0.drawRect(cc.p(0,0), cc.p(50,50), null, 5, cc.color(255,0,0,255));
        };
    },
    testAcceleration: function() {
        this.setLabelTest(3);
        this.schedule(function(dt) {
            if( inputManager.acc ) {
                this.lbsTest[0].setString("x: "+inputManager.acc.x);
                this.lbsTest[1].setString("y: "+inputManager.acc.y);
                this.lbsTest[2].setString("z: "+inputManager.acc.z);
            }
        });
    },
    testInputVar: function() {
        this.setLabelTest(inputManager.buttonsNum);
        this.schedule(function(dt) {
            for( var i = inputManager.buttonsNum; i--; ) {
                if( inputManager.buttons[i].pressed ) {
                    if( inputManager.buttons[i].hit ) {
                        this.lbsTest[i].setString("Button"+i+" Hit!!!!");
                    }
                    else {
                        this.lbsTest[i].setString("Button"+i+" Pressed");
                    }
                }
                else {
                    if( inputManager.buttons[i].releaseHit ) {
                        this.lbsTest[i].setString("Button"+i+" ReleaseHit!!!!");
                    }
                    else {
                        this.lbsTest[i].setString("Button"+i+" Released");
                    }
                }
            }
        });

    }
});

// 게이지 색상 배열.
var colorsGauge = [
    cc.color(241,30,118),   // 빨
    cc.color(153,222,15),   // 초
    cc.color(34,171,254),   // 파
    cc.color(143,57,254),   // 보
    cc.color(254,226,33)    // 노
];

// 현재 색상 인덱스.
var curColorIndex = 0;

// 콜라이더를 DrawNode 로 표시할 것인지 여부.
var bShowCollider = false;

// 게이지 하단 높이
var GAUGE_HEIGHT;

// 로딩레이어. 안드로이드에서만 사용된다.
var LoadingLayer = cc.Layer.extend({
    ctor: function() {
        this._super();

        this.setCascadeOpacityEnabled(true);

        this.loading = new cc.Sprite(res.LaunchAndroid_png);
        this.addChild(this.loading, 100);
        this.loading.setPosition(winCenter);

        this.listener = cc.eventManager.addListener({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function (touch, event) {
                return true;
            }
        }, this);
    },
    onExit: function() {
        cc.eventManager.removeListener(this.listener);
        this._super();
    }
});

