/**
 * Created by kominpyo on 15. 8. 12..
 */

var Gain = cc.Node.extend({

    onExit: function() {
        this.actColor.release();

        this._super();
    },

    ctor: function() {
        this._super();

        this.sprite = new cc.Sprite("#NumberItem1.png");
        this.addChild(this.sprite);

        //this.sprite = new cc.LabelAtlas("2", res.NumberTime_png, 21, 24, '0');
        //this.addChild(this.sprite);
        //this.sprite.setAnchorPoint(0.5, 0.5);
        //this.sprite.scale = 1.5;

        this.valueTime = 2;

        this.velY = 0;
        this.velX = 0;

        this.accY = -2000;

        // 색상 변화 액션.
        var timeTint = 0.12;
        this.actColor = cc.repeatForever(
            cc.sequence(
                cc.tintTo(timeTint, 255,202,0),
                cc.tintTo(timeTint, 255,80,255),
                cc.tintTo(timeTint, 0,179,255)
            )
        );
        this.actColor.retain();

        if( bShowCollider ) {
            this.drawNodeCol = new cc.DrawNode();
            this.addChild(this.drawNodeCol);
            this.drawNodeCol.drawCircle(cc.p(0,0), Gain.colRadius, 0, 10, false, 1, cc.color(255,0,0,255));
        }
    },
    reuse: function() {
        this.visible = true;

        // 랜덤 시간 증가값 설정.
        this.valueTime = g_systemManager.randomRangeUnit(1, 3, 1);
        //this.sprite.setString(this.valueTime);
        this.sprite.setSpriteFrame("NumberItem"+this.valueTime+".png");

        this.velY = 0;
        this.velX = (Math.random() < 0.5 ? 1 : -1) * g_systemManager.randomRange(0, 50);

        this.rotateSpeed = g_systemManager.randomRange(0.5,1)*(this.velX < 0 ? -1:1) * 400;


        this.scheduleUpdate();

        this.sprite.runAction(this.actColor);
    },
    unuse: function() {
        this.visible = false;

        this.unscheduleUpdate();

        this.sprite.stopAllActions();
    },

    update: function(dt) {
        this.velY += dt * this.accY;
        this.y += dt * this.velY;

        if( this.y <= LAND_POS_Y +10)  {
            this.y = LAND_POS_Y +10;

            if( this.velY > -100 ) {
                this.unscheduleUpdate();

                return;
            }
            this.velY = -this.velY * 0.3;
        }

        this.x += dt * this.velX;

        this.rotation += dt * this.rotateSpeed;

    },

    timeMoveToGauge: 0.5,
    collideWithPlayer: function() {
        this.unscheduleUpdate();

        // 획득후 바로 죽었을때를 대비해 더할 점수를 저장해놓는다.
        g_systemManager.lastPlusScore = this.valueTime;

        var posX = g_guiLayer.getGaugePosXAfterTime(this.timeMoveToGauge);
        var seq = cc.sequence(
            new cc.EaseIn(cc.moveTo(this.timeMoveToGauge, cc.p(posX, GAUGE_HEIGHT)), 1.6),
            cc.callFunc(function() {
                // 점수(=타임) 증가.
                g_systemManager.addScore(this.valueTime);
                // 게이지 색상변화 이펙트.
                g_guiLayer.runEffectGaugeColor();

                // 사운드
                cc.audioEngine.playEffect(res.SoundGaugeUp);

                g_systemManager.lastPlusScore = 0;

                cc.pool.putInPool(this);
            }, this)
        );
        this.runAction(seq);
    }
});
// 충돌 반경.
Gain.colRadius = 30;
