/**
 * Created by kominpyo on 15. 8. 11..
 */

var g_player;

var MoveHPlayer = cc.Node.extend({
    MOVE_SPEED : 468,           // 좌우 이동 속도.
    STOP_POS_OFFSET: 20,        // 좌우 끝에서 멈추는 위치.

    COL_RADIUS_HEAD: 21,                    // 머리 충돌 반경.
    COL_CENTER_POINT_HEAD: cc.p(0, 30),     // 머리 충돌 중심점.

    normalAnimSpeed: 1,         // 일반 애니메이션 속도.

    moveDir: 0,     // 이동중인 방향. 0: 멈춤, 1: 오른쪽, -1: 왼쪽.


    ctor: function() {
        this._super();
        g_player = this;

        this.init();
    },
    // 생성시 초기화.
    init: function() {
        // 웃음 애니 상태 변수.
        this.bStateSmile = false;

        // 캐릭터 스파인 애니메이션
        // (150812 Idle, Run 을 가지고 있다.)
        this.spine = new sp.SkeletonAnimation(res.Stickman_json, res.Stickman_atlas);
        this.addChild(this.spine);

        this.spine.setScale(1.105);

        // 애니메이션 속도 설정.
        this.spine.setTimeScale(1);

        // 스킨 설정.
        //this.spine.setSkin("1");

        this.shadow = new cc.Sprite("#Shadow.png");
        this.addChild(this.shadow, -1);
        this.shadow.setScaleX(0.4);


        this.startPos = cc.p(winCenter.x, LAND_POS_Y);   // 시작 위치 설정.


        // 충돌영역 설정.
        this.setupCollider();


        this.reset();
    },

    setupCollider: function() {
        if( bShowCollider ) {
            this.drawNodeCol = new cc.DrawNode();
            this.addChild(this.drawNodeCol);
            this.drawNodeCol.drawCircle(this.COL_CENTER_POINT_HEAD, this.COL_RADIUS_HEAD, 0, 10, false, 1, cc.color(255,0,0,255));
        }
    },

    // 게임 시작시 초기화.
    reset: function() {
        this.bStateSmile = false;           // 웃음 애니 상태 변수 초기화.
        // 웃음상태 스케줄이 등록되었다면 제거.
        this.unschedule("setStateSmileFalse");

        this.spine.visible = true;
        this.setPosition(this.startPos);   // 위치 초기화.

        this.setAnimation("Idle", true);     // Idle 애니메이션 재생.

        // 이동 관련 변수 초기화.
        this.moveDir = 0;
        this.moveSpeed = this.MOVE_SPEED;

        // 사운드 변수 초기화.
        this.audioIdRun = null;
    },

    setGameStart: function() {

    },
    setDie: function() {
        this.spine.visible = false;
        // 애니메이션 정지.
        this.spine.clearTrack(0);

        // Sound
        cc.audioEngine.playEffect(res.SoundDie);
        // 죽음시 목소리 0.3초 뒤 재생.
        this.scheduleOnce(function() {
            cc.audioEngine.playEffect(res.SoundDieShout[g_systemManager.randomRangeUnit(0, 1, 1)]);
        }, 0.1);


        // 달리기 사운드 재생 멈춤.
        if( this.audioIdRun ) {
            cc.audioEngine.stopEffect(this.audioIdRun);
            this.audioIdRun = null;
        }
    },

    mainMenuToPlay: function() {
        this.setGameStart();
    },
    playToPlayEnd: function() {
        this.setDie();
    },
    playEndToMainMenu: function() {
        this.reset();

    },


    update: function(dt) {
        // 좌우 이동.
        // 현재 이동 상태에 따라 입력처리를 해준다.
        if( this.moveDir == 0 ) {   // Idle 상태 이면,
            if( inputManager.buttons[0].pressed ) {
                this.setMoveLeft();
            }
            else if( inputManager.buttons[1].pressed ) {
                this.setMoveRight();
            }
        }
        else if( this.moveDir == 1 ) {	// 오른쪽 이동중이면,
            if( inputManager.buttons[0].hit ) {
                this.setMoveLeft();
            }
            else if( !inputManager.buttons[1].pressed ) {   // 오른쪽 이동중에 오른쪽 터치를 뗐을때.
                if( inputManager.buttons[0].pressed ) {     // 왼쪽 터치가 눌려있으면 왼쪽으로 이동.
                    this.setMoveLeft();
                }
                else {
                    this.setIdle();
                }
            }
        }
        else if( this.moveDir == -1 ) {	// 왼쪽 이동중이면,
            if( inputManager.buttons[1].hit ) {
                this.setMoveRight();
            }
            else if( !inputManager.buttons[0].pressed ) {   // 왼쪽 이동중에 왼쪽 터치를 뗐을때.
                if( inputManager.buttons[1].pressed ) {     // 오른쪽 터치가 눌려있으면 오른쪽으로 이동.
                    this.setMoveRight();
                }
                else {
                    this.setIdle();
                }
            }
        }

        // 플레이어 이동
        // 위에서 결정된 moveDir 값을 가지고 이동시킨다.
        this.x += dt * this.moveDir * this.moveSpeed;

        if( this.x > winSize.width - this.STOP_POS_OFFSET ) {
            this.x = winSize.width - this.STOP_POS_OFFSET;
        }
        else if( this.x < this.STOP_POS_OFFSET ) {
            this.x = this.STOP_POS_OFFSET;
        }

    },

    // 이동 상태 설정.
    setIdle: function() {
        if( this.moveDir != 0 ) {
            this.moveDir = 0;
        }

        this.setAnimation("Idle", true);

        // Stop Sound Run
        if( this.audioIdRun ) {
            cc.audioEngine.stopEffect(this.audioIdRun);
            this.audioIdRun = null;
        }
    },
    setMoveRight: function() {
        this.moveDir = 1;
        if( this.getScaleX() < 0 ) {
            this.setScaleX(1);
        }

        this.setAnimation("Run", true);

        // Sound
        if( !this.audioIdRun ) {
            this.audioIdRun = cc.audioEngine.playEffect(res.SoundRun, true);
        }
    },
    setMoveLeft: function() {
        this.moveDir = -1;
        if( this.getScaleX() > 0 ) {
            this.setScaleX(-1);
        }

        this.setAnimation("Run", true);

        // Sound
        if( !this.audioIdRun ) {
            this.audioIdRun = cc.audioEngine.playEffect(res.SoundRun, true);
        }
    },

    obtainGain: function() {
        this.setStateSmile(true);
        this.scheduleOnce(function() {
            this.setStateSmile(false);
        }, 2, "setStateSmileFalse");
    },
    setStateSmile: function(bState) {
        this.bStateSmile = bState;
        // 현재 상태에 따라 애니 재생.
        if( this.moveDir == 0 ) {
            this.setAnimation("Idle", true);
        }
        else {
            this.setAnimation("Run", true);
        }
    },

    setAnimation: function(animName, bLoop) {
        if( animName == "Run" ) {
            if( this.bStateSmile ) {
                this.spine.setAnimation(0, "RunSmile", bLoop || false);
            }
            else {
                this.spine.setAnimation(0, animName + g_systemManager.randomRangeUnit(0, 3, 1), bLoop || false);
            }
        }
        else {
            if( this.bStateSmile ) {
                this.spine.setAnimation(0, "IdleSmile", bLoop || false);
            }
            else {
                this.spine.setAnimation(0, animName, bLoop || false);
            }
        }

        //if( animName == "Run" ) {
        //    this.spine.setTimeScale(this.runAnimSpeed);
        //}
        //else {
        //    this.spine.setTimeScale(this.normalAnimSpeed);
        //}
    }

});