/**
 * Created by kominpyo on 15. 7. 8..
 */

cc.GLNode = cc.GLNode || cc.Node.extend({
    ctor:function(){
        this._super();
        this.init();
    },
    init:function(){
        this._renderCmd._needDraw = true;
        this._renderCmd.rendering =  function(ctx){
            cc.kmGLMatrixMode(cc.KM_GL_MODELVIEW);
            cc.kmGLPushMatrix();
            cc.kmGLLoadMatrix(this._stackMatrix);

            this._node.draw(ctx);

            cc.kmGLPopMatrix();
        };
    },
    draw:function(ctx){
        this._super(ctx);
    }
});
cc.GLNode.extend = cc.Class.extend;




var GLNodeBase = cc.Node.extend({
    glnode: null,
    ctor:function(fileName, fShaderFileName, vShaderFileName) {
        this._super();

        this.glnode = new cc.GLNode();
        this.addChild(this.glnode);
        this.glnode.setAnchorPoint(0.5, 0.5);

        this.initShader(fShaderFileName, vShaderFileName);

        this.initGL(fileName);

        //this.draw = this.drawFunc.bind(this);
        this.glnode.draw = this.drawFunc.bind(this);

        //this.setAnchorPoint(0.5, 0.5);
    },
    drawFunc: function() {

        this.shader.use();
        this.shader.setUniformsForBuiltins();

        //cc.glBlendFunc(this.getBlendFunc().src, this.getBlendFunc().dst);
        gl.bindTexture(gl.TEXTURE_2D, this.my_texture.getName());
        //gl.bindTexture(gl.TEXTURE_2D, this.getTexture().getName() );
        cc.glEnableVertexAttribs( cc.VERTEX_ATTRIB_FLAG_POSITION | cc.VERTEX_ATTRIB_FLAG_COLOR | cc.VERTEX_ATTRIB_FLAG_TEX_COORDS );


        // Draw fullscreen Square
        gl.bindBuffer(gl.ARRAY_BUFFER, this.squareVertexPositionBuffer);
        gl.vertexAttribPointer(cc.VERTEX_ATTRIB_POSITION, 2, gl.FLOAT, false, 0, 0);

        gl.bindBuffer(gl.ARRAY_BUFFER, this.squareVertexTextureBuffer);
        gl.vertexAttribPointer(cc.VERTEX_ATTRIB_TEX_COORDS, 2, gl.FLOAT, false, 0, 0);

        gl.bindBuffer(gl.ARRAY_BUFFER, this.squareVertexColorBuffer);
        gl.vertexAttribPointer(cc.VERTEX_ATTRIB_COLOR, 4, gl.FLOAT, true, 0, 0);

        gl.drawArrays(gl.TRIANGLE_STRIP, 0, 4);

        gl.bindTexture(gl.TEXTURE_2D, null);
        gl.bindBuffer(gl.ARRAY_BUFFER, null);


    },

    initShader: function(fShaderFileName, vShaderFileName) {
        if( 'opengl' in cc.sys.capabilities ) {
            if(cc.sys.isNative){
                //this.shader = new cc.GLProgram(vShaderFileName || res.default_native_vsh,
                //    fShaderFileName || res.default_fsh);
                this.shader = new cc.GLProgram(vShaderFileName || res.default_vsh,
                    fShaderFileName || res.default_fsh);
                this.shader.link();
                this.shader.updateUniforms();
            }
            else{
                this.shader = new cc.GLProgram(vShaderFileName || res.default_vsh,
                    fShaderFileName || res.default_fsh);
                this.shader.retain();

                this.shader.addAttribute(cc.ATTRIBUTE_NAME_POSITION, cc.VERTEX_ATTRIB_POSITION);
                this.shader.addAttribute(cc.ATTRIBUTE_NAME_TEX_COORD, cc.VERTEX_ATTRIB_TEX_COORDS);
                this.shader.addAttribute(cc.ATTRIBUTE_NAME_COLOR, cc.VERTEX_ATTRIB_COLOR);

                this.shader.link();
                this.shader.updateUniforms();
                this.shader.use();
            }

            if(cc.sys.isNative){
                //this.glProgramState = cc.GLProgramState.getOrCreateWithGLProgram(this.shader);
                this.glnode.glProgramState = cc.GLProgramState.getOrCreateWithGLProgram(this.shader);

                //this.setGLProgramState(this.glProgramState);
                this.glnode.setGLProgramState(this.glnode.glProgramState);
            }else{
                //this.shaderProgram = this.shader;
                this.glnode.shaderProgram = this.shader;
            }

        }
    },
    initShader1: function(fShaderFileName, vShaderFileName) {
        if(cc.sys.isNative) {
            this.shader = cc.GLProgram.create(vShaderFileName || res.default_vsh,
                fShaderFileName || res.default_fsh);
        }
        else {
            this.shader = cc.GLProgram.create(vShaderFileName || res.default_native_vsh,
                fShaderFileName || res.default_fsh);
        }
        this.shader.retain();
        this.shader.addAttribute("aVertex", cc.VERTEX_ATTRIB_POSITION);
        this.shader.link();
        this.shader.updateUniforms();
    },

    initGL:function(fileName) {
        //var texture = this.my_texture = gl.createTexture();
        //gl.bindTexture( gl.TEXTURE_2D, texture );

        //var texture2d = this.my_texture = cc.textureCache.getTextureForKey(res.MaskLight_png);    // 웹에서는 동작하지만, 아이폰에서 안된다.
        var texture2d = this.my_texture = cc.textureCache.addImage(fileName);    // 이렇게 하면 웹과 아이폰 둘다 된다.
        gl.bindTexture(gl.TEXTURE_2D, texture2d.getName());

        gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MAG_FILTER, gl.LINEAR);
        gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MIN_FILTER, gl.LINEAR);
        gl.bindTexture(gl.TEXTURE_2D, null);

        // set glnode width, height
        //this.width = texture2d.width;
        //this.height = texture2d.height;
        this.glnode.width = texture2d.width;
        this.glnode.height = texture2d.height;


        // Square
        // vertices
        var squareVertexPositionBuffer = this.squareVertexPositionBuffer = gl.createBuffer();
        gl.bindBuffer(gl.ARRAY_BUFFER, squareVertexPositionBuffer);
        //var vertices = [
        //    128,  128,
        //    0,    128,
        //    128,  0,
        //    0,    0
        //];
        //var vertices = [
        //    this.width,  0,
        //    0,    0,
        //    this.width,  this.height,
        //    0,    this.height
        //];
        var vertices = [
            this.glnode.width,  0,
            0,    0,
            this.glnode.width,  this.glnode.height,
            0,    this.glnode.height
        ];
        gl.bufferData(gl.ARRAY_BUFFER, new Float32Array(vertices), gl.STATIC_DRAW);

        // texcoords
        var squareVertexTextureBuffer = this.squareVertexTextureBuffer = gl.createBuffer();
        gl.bindBuffer(gl.ARRAY_BUFFER, squareVertexTextureBuffer);
        var texcoords = [
            1, 1,
            0, 1,
            1, 0,
            0, 0
        ];
        gl.bufferData(gl.ARRAY_BUFFER, new Float32Array(texcoords), gl.STATIC_DRAW);

        // colors
        var colors = [
            1.0, 1.0, 1.0, 1.0,
            1.0, 1.0, 1.0, 1.0,
            1.0, 1.0, 1.0, 1.0,
            1.0, 1.0, 1.0, 1.0
        ];
        var squareVertexColorBuffer = this.squareVertexColorBuffer = gl.createBuffer();
        gl.bindBuffer(gl.ARRAY_BUFFER, squareVertexColorBuffer);
        gl.bufferData(gl.ARRAY_BUFFER, new Float32Array(colors), gl.STATIC_DRAW);

        gl.bindBuffer(gl.ARRAY_BUFFER, null);

    },

    setPercent: function(percent) {
        if(cc.isNumber(percent)) {
            this.percent = percent;
        }
        if ('opengl' in cc.sys.capabilities) {
            if (cc.sys.isNative) {
                //this.glProgramState.setUniformFloat("u_percent", this.percent);
                //this.glnode.glProgramState.setUniformFloat("u_percent", this.percent);

                if( this.ulPercent === undefined ) {
                    var program = this.shader.getProgram();
                    this.ulPercent = gl.getUniformLocation( program, "u_percent");
                }

                this.shader.setUniformLocationF32( this.ulPercent, this.percent);
            }
            else {
                this.shader.use();
                this.shader.setUniformLocationWith1f(this.shader.getUniformLocationForName("u_percent"), this.percent);
                this.shader.updateUniforms();
            }
        }
    }

});
GLNodeBase.extend = cc.Class.extend;
