/**
 * Created by kominpyo on 2015. 3. 18..
 */


var ShaderSprite = cc.Sprite.extend({
    ctor: function(spriteFileName, fShaderFileName) {
        this._super(spriteFileName);

        this.initShader(fShaderFileName);
    },
    initShader: function(fShaderFileName) {
        if( 'opengl' in cc.sys.capabilities ) {
            if(cc.sys.isNative){
                this.shader = new cc.GLProgram(res.default_native_vsh, fShaderFileName || res.default_fsh);
                this.shader.link();
                this.shader.updateUniforms();
            }
            else{
                this.shader = new cc.GLProgram(res.default_vsh, fShaderFileName || res.default_fsh);

                this.shader.addAttribute(cc.ATTRIBUTE_NAME_POSITION, cc.VERTEX_ATTRIB_POSITION);
                this.shader.addAttribute(cc.ATTRIBUTE_NAME_TEX_COORD, cc.VERTEX_ATTRIB_TEX_COORDS);
                this.shader.addAttribute(cc.ATTRIBUTE_NAME_COLOR, cc.VERTEX_ATTRIB_COLOR);

                this.shader.link();
                this.shader.updateUniforms();
                this.shader.use();
                //this.shader.setUniformLocationWith1f(this.shader.getUniformLocationForName('u_threshold'), 1.75);
                //this.shader.setUniformLocationWith3f(this.shader.getUniformLocationForName('u_outlineColor'), 0 / 255, 255 / 255, 0 / 255);
            }

            if(cc.sys.isNative){
                this.glProgramState = cc.GLProgramState.getOrCreateWithGLProgram(this.shader);
                //glProgram_state.setUniformFloat("u_threshold", 1.75);
                //glProgram_state.setUniformVec3("u_outlineColor", {x: 0/255, y: 255/255, z: 0/255});

                this.setGLProgramState(this.glProgramState);
            }else{
                this.shaderProgram = this.shader;
            }

        }
    }

});
ShaderSprite.extend = cc.Class.extend;


