/**
 * Created by kominpyo on 2015. 4. 26..
 */

var g_playScene;

var PlayScene = cc.Scene.extend({

    ctor: function() {
        this._super();
        g_playScene = this;

        // 줌 인/아웃을 위한 노드.
        this.nodeZoom = new cc.Node();
        this.addChild(this.nodeZoom);
        this.nodeZero = new cc.Node();
        this.nodeZoom.addChild(this.nodeZero);


        this.playLayer = new PlayLayer();
        this.nodeZero.addChild(this.playLayer);
        this.guiLayer = new GUILayer();
        this.nodeZero.addChild(this.guiLayer);

        this.scheduleUpdate();
    },

    mainMenuToPlay: function() {
        this.playLayer.mainMenuToPlay();
        this.guiLayer.mainMenuToPlay();
    },
    playToPlayEnd: function() {
        this.playLayer.playToPlayEnd();
        this.guiLayer.playToPlayEnd();
    },
    playEndToMainMenu: function() {
        this.playLayer.playEndToMainMenu();
        this.guiLayer.playEndToMainMenu();
    },


    update: function(dt) {
        dt = 0.0166;
        this.playLayer.update(dt);

        //this.guiLayer.update(dt);
    },

    shakeScene: function(time, distMax) {
        this.timerShake = time;
        this.countInterval = 0;
        this.shakeInterval = 0.033;
        this.shakeDistMax = distMax;
        this.shakeDistDecreaseSpeed = distMax / time;

        this.shakePosSignX = Math.random() < 0.5 ? -1 : 1;
        this.shakePosSignY = Math.random() < 0.5 ? -1 : 1;

        this.schedule(this.updateShakeScene);
    },
    updateShakeScene: function(dt) {
        this.timerShake -= dt;
        if( this.timerShake < 0 ) {
            this.unschedule(this.updateShakeScene);
            this.setPosition(0, 0);
            return;
        }

        this.countInterval += dt;
        if( this.countInterval >= this.shakeInterval ) {
            this.countInterval -= this.shakeInterval;

            var prob = Math.random();
            if( prob < 0.5 ) {
                this.shakePosSignX = -this.shakePosSignX;
                this.shakePosSignY = -this.shakePosSignY;
            }
            else if( prob < 0.75 ) {
                this.shakePosSignX = -this.shakePosSignX;
            }
            else {
                this.shakePosSignY = -this.shakePosSignY;
            }

            this.shakeDistMax -= dt * this.shakeDistDecreaseSpeed;
            this.setPosition(this.shakeDistMax * this.shakePosSignX,
                this.shakeDistMax * this.shakePosSignY );
            //this.playLayer.setPosition(this.shakeDistMax * this.shakePosSignX,
            //    this.shakeDistMax * this.shakePosSignY );
        }

    },

    zoomScene: function(zoomInTime, zoomOutTime, zoomInMaxScale) {
        var posPlayer = g_player.getPosition();
        this.nodeZoom.setPosition(posPlayer.x, posPlayer.y +15);
        this.nodeZero.setPosition(-this.nodeZoom.x, -this.nodeZoom.y);

        this.nodeZoom.runAction(
            cc.sequence(
                cc.scaleTo(zoomInTime, zoomInMaxScale),
                cc.scaleTo(zoomOutTime, 1),
                cc.callFunc(function() {
                    this.nodeZoom.setPosition(0,0);
                    this.nodeZero.setPosition(0,0);
                }, this)
            )
        );
    }
});