/**
 * Created by kominpyo on 2015. 4. 26..
 */


var SystemState = {
    Loading: 0,
    MainMenu: 1,
    Play: 2,
    PlayEnd: 3,
    Pause: 4
};


var g_systemManager = {
    systemState: SystemState.Loading,
    scoreReal: 0,       // 실수로 표현된 점수. 소수점 제한 없다.
    score: 0,           // 소수점 2자리까지 표현한 점수. 표시하는 점수다.
    lastPlusScore: 0,   // 획득후 바로 죽었을때를 대비해 더할 점수.
    myHighScore: 0,
    isSoundOn: true,

    loadSound: function() {
        // 웹에서는 preload 메서드가 없다.
        if( cc.sys.isNative ) {
            cc.audioEngine.preloadEffect(res.SoundDie);
            cc.audioEngine.preloadEffect(res.SoundButton);

            cc.audioEngine.preloadEffect(res.SoundClock);
            cc.audioEngine.preloadEffect(res.SoundDieShout[0]);
            cc.audioEngine.preloadEffect(res.SoundDieShout[1]);
            cc.audioEngine.preloadEffect(res.SoundRun);
            cc.audioEngine.preloadEffect(res.SoundGetNumber);
            cc.audioEngine.preloadEffect(res.SoundGaugeUp);

            cc.audioEngine.preloadEffect(res.SoundBall);
        }
        else {
            //cc.audioEngine.playMusic(res.SoundBgm, true);
            //cc.audioEngine.stopMusic();

            //cc.audioEngine.playEffect(res.SoundButton0);
            //cc.audioEngine.stopAllEffects();
        }
    },

    resetVariables: function() {
        this.scoreReal = 0;
        this.score = 0;
        this.lastPlusScore = 0;
        g_guiLayer.refreshGauge(this.score);
    },

    addScore: function(addValue) {
        this.scoreReal += addValue;
        this.score = Math.floor(this.scoreReal*100)/100;
        g_guiLayer.refreshGauge(this.score);
    },

    loadingToMainMenu: function() {
        this.systemState = SystemState.MainMenu;

        this.loadSound();

        //cc.sys.localStorage.removeItem("MyHighScore");
        // 내 최고점수 로드.
        this.myHighScore = cc.sys.localStorage.getItem("MyHighScore");
        // 해당 키값이 존재하지 않는 경우.
        // 웹과 아이폰에서는 null 을 반환하고,
        // 안드로이드에서는 ""(빈문자열) 을 반환한다.
        if( this.myHighScore == null || this.myHighScore == "") {
            this.myHighScore = 0;
        }
        if( g_guiLayer ) {
            g_guiLayer.refreshBestScore(this.myHighScore);
        }

        // Admob Banner
        this.showBannerView(1, 0);
        // Admob Interstitial
        this.requestInterstitialAd();
    },
    mainMenuToPlay: function() {
        this.systemState = SystemState.Play;

        g_playScene.mainMenuToPlay();

        // Admob Banner
        this.hideBannerView();
    },
    playToPlayEnd: function() {
        this.systemState = SystemState.PlayEnd;

        // 내 최고점수 저장.
        this.score += this.lastPlusScore;
        if( this.score > this.myHighScore ) {
            this.myHighScore = this.score;
            cc.sys.localStorage.setItem("MyHighScore", this.myHighScore);

            g_guiLayer.refreshBestScore(this.myHighScore);
        }

        g_playScene.playToPlayEnd();

        // 전면광고 띄울 조건을 위해 플레이 횟수를 카운트한다.
        ++this.countPlayNumForAd;
        // 전면광고 띄울 조건을 위해 누적점수를 구한다.
        this.sumScoreForAd += this.score;

        // Admob Banner
        this.showBannerView(1, 2);
        // Admob Interstitial
        //this.showInterstitialAd();

        // reportScore
        // GUILayer에서 PlayEnd UI 연출이 시작될때 호출하도록 수정함.
        //this.reportScore(this.score);
    },
    playEndToMainMenu: function() {
        this.systemState = SystemState.MainMenu;

        this.resetVariables();
        g_playScene.playEndToMainMenu();

        // Admob Banner
        this.showBannerView(1, 0);
        // Admob Interstitial
        this.requestInterstitialAd();
    },
    playEndToPlay: function() {
        this.systemState = SystemState.Play;

        this.resetVariables();
        g_playScene.playEndToPlay();

    },

    toggleSound: function() {
        this.isSoundOn = !this.isSoundOn;
        if( this.isSoundOn ) {
            //cc.audioEngine.playMusic(res.SoundBgm, true);
            cc.audioEngine.setMusicVolume(1);
            cc.audioEngine.setEffectsVolume(1);
        }
        else {
            cc.audioEngine.stopMusic();
            cc.audioEngine.stopAllEffects();
            cc.audioEngine.setMusicVolume(0);
            cc.audioEngine.setEffectsVolume(0);
        }
    },

    // 전면광고는 구현되어 있지 않다.
    // 아래 소스코드는 호출되지 않는다.
    // 전면 광고 조건 구현.
    // 기본 조건 : 30점 이상, 3판이상 플레이
    countPlayNumForAd: 0,
    sumScoreForAd: 0,
    showInterstitialAdByCondition: function() {
        var bShowInterstitial = false;
        if( this.countPlayNumForAd >= 3 && this.sumScoreForAd >= 45) {
            bShowInterstitial = true;
        }

        if( bShowInterstitial ) {
            this.sumScoreForAd = 0;
            this.countPlayNumForAd = 0;

            this.showInterstitialAd();
        }
    },


    // Admob 구현
    // horizontalIndex  0: left, 1: center, 2:right
    // verticalIndex  0: top,  1: middle, 2: bottom
    showBannerView: function(horizontalIndex, verticalIndex) {
        if( cc.sys.os == cc.sys.OS_ANDROID && bReadyAndroidExternalFunc ) {
            jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity", "showBannerView", "(II)V", horizontalIndex, verticalIndex);
        }
        else if( cc.sys.os == cc.sys.OS_IOS && bReadyIOSAdmob ) {
            jsb.reflection.callStaticMethod("AdMob", "showBannerViewWithHIndex:VIndex:", horizontalIndex, verticalIndex);
        }
    },
    hideBannerView: function() {
        if( cc.sys.os == cc.sys.OS_ANDROID && bReadyAndroidExternalFunc ) {
            jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity", "hideBannerView", "()V");
        }
        else if( cc.sys.os == cc.sys.OS_IOS && bReadyIOSExternalFunc ) {
            jsb.reflection.callStaticMethod("AdMob", "hideBannerView");
        }
    },
    requestInterstitialAd: function() {
        if( cc.sys.os == cc.sys.OS_ANDROID && bReadyAndroidExternalFunc ) {
            jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity", "requestInterstitialAd", "()V");
        }
        else if( cc.sys.os == cc.sys.OS_IOS && bReadyIOSExternalFunc ) {
            jsb.reflection.callStaticMethod("AdMob", "staticRequestInterstitialAd");
        }
    },
    showInterstitialAd: function() {
        if( cc.sys.os == cc.sys.OS_ANDROID && bReadyAndroidExternalFunc ) {
            jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity", "showInterstitialAd", "()V");
        }
        else if( cc.sys.os == cc.sys.OS_IOS && bReadyIOSExternalFunc ) {
            jsb.reflection.callStaticMethod("AdMob", "staticShowInterstitialAd");
        }
    },

    // GameCenter, Google 리더보드 구현
    reportScore: function(score) {
        if( cc.sys.os == cc.sys.OS_ANDROID && bReadyAndroidExternalFunc ) {
            jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity", "reportScore", "(I)V", score);
        }
        else if( cc.sys.os == cc.sys.OS_IOS && bReadyIOSExternalFunc ) {
            jsb.reflection.callStaticMethod("GameCenter", "reportScore:", score);
        }
    },
    showLeaderboard: function() {
        if( cc.sys.os == cc.sys.OS_ANDROID && bReadyAndroidExternalFunc ) {
            jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity", "showLeaderboard", "()V");
        }
        else if( cc.sys.os == cc.sys.OS_IOS && bReadyIOSExternalFunc ) {
            jsb.reflection.callStaticMethod("GameCenter", "showLeaderboard");
        }
    },

    // 리뷰 페이지 열기.
    openReviewPage: function() {
        if( cc.sys.os == cc.sys.OS_ANDROID ) {
            jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity", "openReviewPage", "()V");
        }
        else if( cc.sys.os == cc.sys.OS_IOS && bReadyIOSExternalFunc ) {
            jsb.reflection.callStaticMethod("IosFunctions", "openAppStoreReviewPage");
        }
    },

    // 공유 기능.
    showShareView: function(score) {
        if( cc.sys.os == cc.sys.OS_ANDROID ) {
            //jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity", "showShareView", "(I)V", score);
            jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity", "showShareView", "(F)V", score);
        }
        else if( cc.sys.os == cc.sys.OS_IOS && bReadyIOSExternalFunc ) {
            jsb.reflection.callStaticMethod("IosFunctions", "showShareViewWithScore:", score)
        }
    },

    // 안드로이드 백버튼.
    backButtonClicked: function() {
        // AppActivity.displayDialog(1) 호출. 매개변수로 1을 넘겨주면 종료 다이얼로그를 호출한다.
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity", "displayDialog", "(I)V", 1);
    },


    // Animate 액션 생성 함수.
    // delayPerUnit : 애니메이션에 그대로 전달.
    // spriteFrameName : 스프라이트 파일이름. 숫자이전까지를 문자열로 받는다.
    //              예) 파일명이 "CharacterRun0.png" 이라면 => "CharacterRun"
    // startIndex : 스프라이트 파일들 중 애니메이션을 시작할 프레임 인덱스. 이 번호부터 애니메이션을 만든다.
    //              default 값은 0.
    createAnimate: function(delayPerUnit, spriteFrameName, startIndex) {
        var index = startIndex || 0;
        var anim = new cc.Animation();
        anim.setDelayPerUnit(delayPerUnit);
        while( true ) {
            var fullname = spriteFrameName+index+".png";
            var spriteFrame = cc.spriteFrameCache.getSpriteFrame(fullname);
            if( !spriteFrame || index > 100 ) {
                if( index == 0 )
                    cc.log("error: in createAnimation() - invalid filename : "+fullname);
                break;
            }
            anim.addSpriteFrame(spriteFrame);
            ++index;
        }
        return new cc.Animate(anim);
    },
    // createAnimate 와 비슷하지만, 같은 애니메이션의 종류가 여러가지 일경우 사용한다.
    // 예1) "CharacterRun1_0.png" => createAnimateArray(0.05, "CharacterRun", 1) : Run0 ~ RunX 까지 X개의 애니메이션이 있다고 할때, Run1 액션을 생성한다.
    // 예2) "CharacterRun2_1_0.png" => createAnimateArray(0.05, "CharacterRun", 2, 1) : 캐릭터가 여러개이고, 각각 Run0 ~ RunX 의 애니메이션을 가지고 있다고 할때, 캐릭터2의 Run1 액션을 생성한다.
    // 예로 든것 처럼 파일명 규칙을 지켜야 함수가 정상 작동한다.
    createAnimateArray: function(delayPerUnit, spriteFrameName, arrayIndex0, arrayIndex1) {
        var index = 0;
        var anim = new cc.Animation();
        anim.setDelayPerUnit(delayPerUnit);
        while( true ) {
            var fullname;
            if( arrayIndex1 == undefined )
                fullname = spriteFrameName+arrayIndex0+"_"+index+".png";
            else
                fullname = spriteFrameName+arrayIndex0+"_"+arrayIndex1+"_"+index+".png";
            var spriteFrame = cc.spriteFrameCache.getSpriteFrame(fullname);
            if( !spriteFrame || index > 100 ) {
                if( index == 0 )
                    cc.log("error: in createAnimation() - invalid filename : "+fullname);
                break;
            }
            anim.addSpriteFrame(spriteFrame);
            ++index;
        }
        return new cc.Animate(anim);
    },

    // min ~ max 사이의 랜덤 실수값 반환.
    // min 값을 포함하고, max 값은 포함하지 않는다.
    randomRange: function(min, max) {
        return min + (max-min)*Math.random();
    },

    // min ~ max 사이의 값을 unitNum 갯수로 나누어,
    // 그 값들중 하나를 반환. (소수점 가능)
    // min , max 값을 포함한다.
    // => max 값을 포함하므로 unitNum+1 개의 값중에 하나가 반환되게 된다.
    // 예) randomRangeUnitNum(0, 10, 10) 을 호출할 경우
    //    0~10, 11개 중 하나가 반환되게 된다.
    randomRangeUnitNum: function(min, max, unitNum) {
        //var unit = (max-min)/unitNum;
        //return min + Math.floor(Math.random()*(unitNum+1)) * unit;
        return min + Math.floor(Math.random()*(unitNum+1)) * ((max-min)/unitNum);
    },

    // min ~ max 사이의 값을 unit 단위로 나누어,
    // 그 값들중 하나를 반환. (소수점 가능)
    // min , max 값을 포함한다.
    randomRangeUnit: function(min, max, unit) {
        //var unitNumMax = Math.floor((max - min) / unit)+1;
        //return min + unit * Math.floor(Math.random()*unitNumMax);
        //return min + unit * Math.floor(Math.random()*((Math.floor((max - min) / unit)+1)));

        // 150908 소수점 (max-min) 값과 unit 값이 소수점이고,
        // ((max - min) / unit) 의 값이 정수로 나누어 떨어질때
        // Math.floor((max - min) / unit) 의 값이 1 작게 나온다.
        // ((max - min) / unit) 이 x+1 일때 x.999999 의 형태로 들어가는 것으로 보인다.
        // 그래서 0.0001 을 더해주면 문제가 없어진다.
        return min + unit * Math.floor(Math.random()*((Math.floor((max - min) / unit +0.0001)+1)));
    },
    lerp: function(from, to, t) {
        return from + (to-from)*t;
    },
    reverseLerp: function(from, to, target) {
        return (target-from)/(to-from);
    },
    clamp01: function(t) {
        if( t >= 0 && t <= 1 ) return t;
        else if( t > 1 ) return 1;
        else return 0;
    }
};

var Tag = {
    ActionAnim: 10,
    ActionMove: 20,
    ActionEtc: 99
};

var bReadyIOSAdmob = true;
var bReadyIOSExternalFunc = true;
var bReadyAndroidExternalFunc = true;
